unsigned char chr57[][5]={
  {0,0,0,0,0}, //
  {132,16,66,0,1}, // !
  {74,41,0,0,0}, // "
  {74,125,245,149,2}, // #
  {196,23,71,31,1}, // $
  {99,34,34,50,6}, // %
  {162,20,81,147,5}, // &
  {132,8,0,0,0}, // '
  {68,132,16,4,1}, // (
  {4,65,8,17,1}, // )
  {160,58,226,42,0}, // *
  {128,144,79,8,0}, // +
  {0,0,64,136,0}, // ,
  {0,128,15,0,0}, // -
  {0,0,0,0,1}, // .
  {0,34,34,2,0}, // /
  {46,198,24,163,3}, // 0
  {196,16,66,136,3}, // 1
  {46,66,38,194,7}, // 2
  {31,34,6,163,3}, // 3
  {136,169,244,17,2}, // 4
  {63,60,8,163,3}, // 5
  {92,132,23,163,3}, // 6
  {31,34,34,132,0}, // 7
  {46,70,23,163,3}, // 8
  {46,198,15,209,1}, // 9
  {0,16,64,0,0}, // :
  {0,16,64,136,0}, // ;
  {136,136,32,8,2}, // <
  {0,124,240,1,0}, // =
  {130,32,136,136,0}, // >
  {46,34,66,0,1}, // ?
  {46,214,222,130,7}, // @
  {68,197,248,99,4}, // A
  {47,198,23,227,3}, // B
  {46,134,16,162,3}, // C
  {47,198,24,227,3}, // D
  {63,132,23,194,7}, // E
  {63,132,23,66,0}, // F
  {62,132,144,163,7}, // G
  {49,198,31,99,4}, // H
  {142,16,66,136,3}, // I
  {16,66,8,163,3}, // J
  {49,149,81,82,4}, // K
  {33,132,16,194,7}, // L
  {113,215,26,99,4}, // M
  {49,206,154,99,4}, // N
  {46,198,24,163,3}, // O
  {47,198,23,66,0}, // P
  {46,198,88,147,5}, // Q
  {47,198,87,82,4}, // R
  {46,6,7,163,3}, // S
  {159,16,66,8,1}, // T
  {49,198,24,163,3}, // U
  {49,198,24,21,1}, // V
  {49,198,90,119,4}, // W
  {49,42,162,98,4}, // X
  {49,42,66,8,1}, // Y
  {31,34,34,194,7}, // Z
  {127,140,49,198,7}, // [
  {32,8,130,32,0}, // \
  {31,99,140,241,7}, // ]
  {0,16,21,1,0}, // ^
  {255,255,255,255,7}, // _
  {132,32,0,0,0}, // `
  {0,16,21,127,4}, // a
  {0,188,248,226,3}, // b
  {0,248,16,130,7}, // c
  {0,188,24,227,3}, // d
  {0,252,240,194,7}, // e
  {0,252,240,66,0}, // f
  {0,248,16,178,7}, // g
  {0,196,248,99,4}, // h
  {0,56,66,136,3}, // i
  {0,64,8,163,3}, // j
  {0,164,50,74,2}, // k
  {0,132,16,194,7}, // l
  {0,196,93,99,4}, // m
  {0,196,89,115,4}, // n
  {0,184,24,163,3}, // o
  {0,188,248,66,0}, // p
  {0,184,24,147,5}, // q
  {0,188,248,82,4}, // r
  {0,248,224,224,3}, // s
  {0,124,66,8,1}, // t
  {0,196,24,163,3}, // u
  {0,196,24,21,1}, // v
  {0,196,88,235,6}, // w
  {0,68,69,84,4}, // x
  {0,68,69,8,1}, // y
  {0,124,68,196,7}, // z
  {76,136,32,4,3}, // {
  {132,16,64,8,1}, // |
  {6,33,136,144,1}, // }
  {0,140,138,1,0}, // ~
  {255,255,255,255,7}, // User
};

#define XNODE_0 A0
#define XNODE_LEN 5

#define YNODE_0 2
#define YNODE_LEN 7

// およそ1/60sですべてのLEDを処理する
#define LED_ALL_MS (1000 * 1000 / 60)
#define LED_WAIT_MS (LED_ALL_MS / (XNODE_LEN * YNODE_LEN)) 

unsigned char matrix_bit[5] = {0};

void led(int x, int y, bool o){
  if(o == true){
    digitalWrite(XNODE_0 + x, HIGH);
    digitalWrite(YNODE_0 + y, LOW);
  }else{
     digitalWrite(XNODE_0 + x, LOW);
     digitalWrite(YNODE_0 + y, HIGH);   
  }
}
void ledOn(int x, int y){ led(x, y, true); }
void ledOff(int x, int y){ led(x, y, false); }

void setMatrix(int x, int y, bool o){
  int pos = y * XNODE_LEN + x;
  int bytepos = pos / 8;
  int bitpos = pos % 8;
  if(o == true){
    matrix_bit[bytepos] |= (1 << bitpos);
  }else{
    matrix_bit[bytepos] &= ~(1 << bitpos);
  }
}

void clearMatrix(){
  for(int i=0;i<5;i++) matrix_bit[i] = 0;
}

void setMatrixFromChar(char code){
  if(code < ' ') code = ' ';
  else{
    code -= ' ';
    if(code > 95) code = ' ';
  }
  for(int i =0;i<5;i++) matrix_bit[i] = chr57[code][i];
}

void showMatrix(int interval){
  if(interval <= 0) return;
  int ms = millis();
  while(true){
    for(int y=0;y<YNODE_LEN;y++){
      for(int x =0; x < XNODE_LEN;x++){
        int pos =y * XNODE_LEN + x;
        int bytepos = pos / 8;
        int bitpos = pos % 8;
        bool sw = (matrix_bit[bytepos] & (1 << bitpos)) != 0;
        led(sw, x, y);
        delayMicroseconds(LED_WAIT_MS); 
        ledOff(x, y);
      }
    }
    
    int cm = millis();
    if(cm < ms || cm - ms >= interval) return;
  }
}

void showChar(char c, int interval){
  setMatrixFromChar(c);
  showMatrix(interval);
}

void setup() {
  for(int i = XNODE_0; i < XNODE_0 + XNODE_LEN; i++){
    pinMode(i, OUTPUT);
    digitalWrite(i, LOW);
  }

  for(int i = YNODE_0; i < YNODE_0 + YNODE_LEN; i++){
    pinMode(i, OUTPUT);
    digitalWrite(i, HIGH);
  }
}

void loop() {
  showChar('T', 500); 
  showChar('N', 500); 
  showChar('K', 500); 
  showChar('S', 500); 
  showChar('O', 500); 
  showChar('F', 500); 
  showChar('T', 500); 
  showChar(' ', 1000); 
}
